%define major 1.4
%define minor 1
%define build 01
%define distversion %major.%minor-%build
%define arch i586
%define origin blackdown
%define priority 141
%define gccver 3.2

%define jdkver %major.%minor
%define label %major-%origin

%def_disable ns4_plugin

Name: j2se%label
Version: %{jdkver}_%{build}
Release: alt3

Summary: Java 2 Runtime Environment, Standard Edition
Group: System/Base
License: Sun Binary Code License
URL: http://www.blackdown.org/java-linux.html

Packager: Mikhail Zabaluev <mhz@altlinux.ru>

%define distname    j2sdk-%distversion-linux-%arch-gcc%gccver.bin
%define java_home   %_libdir/j2se%label
%define libarch	    i386
%define fontdir     %_datadir/fonts/j2se-sun

# TODO:
# - replace font.properties with font.properties.Redhat6.1
#   (or our customization)?
# - run chkfontpath on font installation?

Provides: j2se = %jdkver
Provides: jre = %jdkver, java2 = %jdkver
# Hack to satisfy autodeps facing Sun's shared library extravaganza
Provides: libverify.so(VER_1)

Requires: j2se-sun-fonts
Requires: java-common

Obsoletes: %name-fonts

%add_findprov_lib_path %java_home/jre/lib/%libarch
%add_findprov_lib_path %java_home/jre/lib/%libarch/client
%add_findprov_lib_path %java_home/jre/lib/%libarch/server
%add_findprov_lib_path %java_home/jre/lib/%libarch/native_threads

%define _verify_elf_method textrel=relaxed

%define _compress_method gzip

Source0: %distname
Source1: %name-profile.sh
Source2: %name-profile.csh

BuildArch: %arch

%package devel
Summary: Java 2 SDK, Standard Edition
Group: Development/Java
Provides: j2se-devel = %jdkver
Provides: jdk = %jdkver, j2sdk = %jdkver
Requires: %name = %version-%release

%package source
Summary: Source files for the Java 2 SDK
Group: Development/Java

%package demo
Summary: Demo applets and programs for the Java 2 SDK
Group: Development/Java

%package plugin-mozilla
Summary: Java Plug-In for Mozilla and Netscape 6
Group: Networking/WWW
Provides: java2-plugin-mozilla = %jdkver
Requires: %name = %version-%release
Requires: mozilla

%if_enabled ns4_plugin
%package plugin-netscape4
Summary: Java Plug-In for Netscape 4.x
Group: Networking/WWW
Provides: java2-plugin-netscape4 = %jdkver
Requires: %name = %version-%release
Requires: netscape-common
%endif

%package jdbc
Summary: Native library for JDBC support in Java
Group: Development/Databases
Provides: j2se-jdbc = %jdkver
Requires: %name = %version-%release

%description
The Java 2 Runtime Environment contains the Java virtual machine, 
runtime class libraries, and Java application launcher that are 
necessary to run programs written in the Java programming language. 
It is not a development environment and does not contain development 
tools such as compilers or debuggers.  For development tools, see the 
Java 2 SDK, Standard Edition.

This package contains J2SE Runtime Environment created by the
Blackdown project based on the source code licensed from Sun Microsystems.
Install this package if you need to run Java applications.

%description devel
The Java 2 SDK is a development environment for building applications,
applets, and components using the Java programming language.

The Java 2 SDK includes tools useful for developing and testing programs
written in the Java programming language and running on the Java platform.

This package contains J2SE SDK created by the Blackdown project
based on the source code licensed from Sun Microsystems.
Install this package if you need to develop and build Java applications.

%description source
Java programming language source files for all classes that make up
the Java 2 core API.

%description demo
Examples, with source code, of programming for the Java platform. These include
examples that use Swing and other Java Foundation Classes, and the Java
Platform Debugger Architecture.

%description plugin-mozilla
This package contains Java(TM) 2 Plug-In for Mozilla and Netsape 6/7
web browsers.

%if_enabled ns4_plugin
%description plugin-netscape4
This package contains Java(TM) 2 Plug-In for Netsape 4.x web browser.
%endif

%description jdbc
This package contains a native dynamic library that provides JDBC support
for the Java platform via the ODBC interface. This library is a part of
the Blackdown J2SE bundle.

%prep
%setup -T -n %name-%version -c
MORE=10000 sh %SOURCE0 <<EOF ||:
yes
EOF
cd j2sdk%jdkver
# fix perms
chmod -R u+w *

echo j2se >j2se-buildreq-substitute
echo j2se-devel >j2se-devel-buildreq-substitute

cat >README.alt <<EOF
The Java 2 Runtime Environment and SDK, Standard Edition are distributed
within this and related packages as shown below:

%name		- Java 2 Runtime Environment, Standard Edition
			  (with notable omissions listed below).
%name-devel	- Java 2 SDK, Standard Edition.
%name-source	- Java 2 Standard Edition API source files.
%name-demo	- Java 2 SDK demo applets and programs.
%name-jdbc	- JDBC provider library using ODBC.
			  This library was excluded from the
			  %name package due to outstanding dependencies.
%name-javaws	- Java Web Start software that is bundled with
			  Java 2 Runtime Environment, Standard Edition
%name-plugin-mozilla	- Java 2 plug-in for Mozilla and Netscape 6/7.
%name-plugin-netscape4	- Java 2 plug-in for Netscape 4.x (optional).

These packages use the TrueType fonts in %fontdir,
provided by the Sun J2SDK binary distribution and shared between
various installations of the Java 2 Runtime Environment.

See the README, LICENSE, and COPYRIGHT files for copyright information,
terms of use and redistribution covering contents of these packages.
EOF

%install
cd j2sdk%jdkver
# Main files
install -d -m755 $RPM_BUILD_ROOT%java_home
cp -a bin include lib $RPM_BUILD_ROOT%java_home
install -d -m755 $RPM_BUILD_ROOT%java_home/jre
cp -a jre/{bin,lib,plugin,JavaPluginControlPanel.html} $RPM_BUILD_ROOT%java_home/jre

# Install profile scripts
install -p -m755 %SOURCE1 $RPM_BUILD_ROOT%java_home/j2se.sh
install -p -m755 %SOURCE2 $RPM_BUILD_ROOT%java_home/j2se.csh

# Demo and sources
install -d -m755 $RPM_BUILD_ROOT%_datadir/%name
cp -a demo $RPM_BUILD_ROOT%_datadir/%name
install -m644 src.zip $RPM_BUILD_ROOT%_datadir/%name

# Link the fonts to the shared fonts directory
rm -rf $RPM_BUILD_ROOT%java_home/jre/lib/fonts
ln -s %fontdir $RPM_BUILD_ROOT%java_home/jre/lib/fonts

# Move and label the manpages
mkdir -p $RPM_BUILD_ROOT%_man1dir
for f in man/man1/*; do
    install -p -m644 $f $RPM_BUILD_ROOT%_man1dir/$(basename $f .1.gz)%label.1.gz
done

# Fix permissions for plugins
find $RPM_BUILD_ROOT%java_home/jre/plugin -type f -name '*.so' -print0 |\
    xargs -r0 chmod 755

# Install substitute rules for buildreq
mkdir -p $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d
install -m644 j2se-buildreq-substitute \
    $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d/%name
install -m644 j2se-devel-buildreq-substitute \
    $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d/%name-devel

# Create list of libraries that go into the main package
find $RPM_BUILD_ROOT%java_home/jre/lib/%libarch -type d -print |\
    sed -e "s|^$RPM_BUILD_ROOT|%dir |" >../libs.list
find $RPM_BUILD_ROOT%java_home/jre/lib/%libarch -name '*.so' \
	! -name libJdbcOdbc.so -print |\
    sed -e "s|^$RPM_BUILD_ROOT||" >>../libs.list

%post
%_sbindir/update-alternatives --install %_libdir/j2se j2se \
    %java_home %priority \
--slave %_bindir/keytool	keytool		%java_home/jre/bin/keytool \
--slave %_bindir/policytool	policytool	%java_home/jre/bin/policytool \
--slave %_bindir/servertool	servertool	%java_home/jre/bin/servertool \
--slave %_sbindir/orbd		orbd		%java_home/jre/bin/orbd \
--slave %_sbindir/rmid		rmid		%java_home/jre/bin/rmid \
--slave %_sbindir/rmiregistry	rmiregistry	%java_home/jre/bin/rmiregistry \
--slave %_sbindir/tnameserv	tnameserv	%java_home/jre/bin/tnameserv \
--slave %_man1dir/java.1.gz		java.1.gz		%_man1dir/java%label.1.gz \
--slave %_man1dir/keytool.1.gz		keytool.1.gz		%_man1dir/keytool%label.1.gz \
--slave %_man1dir/orbd.1.gz		orbd.1.gz		%_man1dir/orbd%label.1.gz \
--slave %_man1dir/policytool.1.gz 	policytool.1.gz 	%_man1dir/policytool%label.1.gz \
--slave %_man1dir/rmid.1.gz		rmid.1.gz		%_man1dir/rmid%label.1.gz \
--slave %_man1dir/rmiregistry.1.gz	rmiregistry.1.gz	%_man1dir/rmiregistry%label.1.gz \
--slave %_man1dir/servertool.1.gz 	servertool.1.gz 	%_man1dir/servertool%label.1.gz \
--slave %_man1dir/tnameserv.1.gz	tnameserv.1.gz		%_man1dir/tnameserv%label.1.gz

%pre
[ -L %java_home/jre/lib/fonts ] || %__rm -rf %java_home/jre/lib/fonts

%preun
if [ $1 = 0 ]; then
    %_sbindir/update-alternatives --remove j2se %java_home
fi

%post devel
update-alternatives --install %_bindir/javac javac \
    %java_home/bin/javac %priority \
--slave %_libdir/jdk		jdk		%java_home \
--slave %_bindir/appletviewer	appletviewer 	%java_home/bin/appletviewer \
--slave %_bindir/extcheck	extcheck 	%java_home/bin/extcheck \
--slave %_bindir/idlj		idlj		%java_home/bin/idlj \
--slave %_bindir/jar		jar		%java_home/bin/jar \
--slave %_bindir/jarsigner	jarsigner	%java_home/bin/jarsigner \
--slave %_bindir/javadoc	javadoc		%java_home/bin/javadoc \
--slave %_bindir/javah		javah		%java_home/bin/javah \
--slave %_bindir/javap		javap		%java_home/bin/javap \
--slave %_bindir/jdb		jdb		%java_home/bin/jdb \
--slave %_bindir/native2ascii	native2ascii	%java_home/bin/native2ascii \
--slave %_bindir/rmic		rmic		%java_home/bin/rmic \
--slave %_bindir/serialver	serialver	%java_home/bin/serialver \
--slave %_sysconfdir/profile.d/j2se.sh	j2se.sh  %java_home/j2se.sh \
--slave %_sysconfdir/profile.d/j2se.csh j2se.csh %java_home/j2se.csh \
--slave %_man1dir/appletviewer.1.gz	appletviewer.1.gz	%_man1dir/appletviewer%label.1.gz \
--slave %_man1dir/extcheck.1.gz		extcheck.1.gz		%_man1dir/extcheck%label.1.gz \
--slave %_man1dir/idlj.1.gz		idlj.1.gz		%_man1dir/idlj%label.1.gz \
--slave %_man1dir/jar.1.gz		jar.1.gz		%_man1dir/jar%label.1.gz \
--slave %_man1dir/jarsigner.1.gz	jarsigner.1.gz		%_man1dir/jarsigner%label.1.gz \
--slave %_man1dir/javac.1.gz		javac.1.gz		%_man1dir/javac%label.1.gz \
--slave %_man1dir/javadoc.1.gz		javadoc.1.gz		%_man1dir/javadoc%label.1.gz \
--slave %_man1dir/javah.1.gz		javah.1.gz		%_man1dir/javah%label.1.gz \
--slave %_man1dir/javap.1.gz		javap.1.gz		%_man1dir/javap%label.1.gz \
--slave %_man1dir/jdb.1.gz		jdb.1.gz		%_man1dir/jdb%label.1.gz \
--slave %_man1dir/native2ascii.1.gz	native2ascii.1.gz	%_man1dir/native2ascii%label.1.gz \
--slave %_man1dir/rmic.1.gz		rmic.1.gz		%_man1dir/rmic%label.1.gz \
--slave %_man1dir/serialver.1.gz	serialver.1.gz		%_man1dir/serialver%label.1.gz

%preun devel
if [ $1 = 0 ]; then
    %_sbindir/update-alternatives --remove javac %java_home/bin/javac
fi

%post plugin-mozilla
if [ -d %_libdir/mozilla/plugins ]; then
    %_sbindir/update-alternatives --install \
        %_libdir/mozilla/plugins/libjavaplugin_oji.so libjavaplugin_oji.so \
        %java_home/jre/plugin/%libarch/mozilla/javaplugin_oji.so %priority
fi

%preun plugin-mozilla
if [ $1 = 0 ]; then
    %_sbindir/update-alternatives --remove libjavaplugin_oji.so \
         %java_home/jre/plugin/%libarch/mozilla/javaplugin_oji.so
fi

%if_enabled ns4_plugin
%post plugin-netscape4
if [ -d %_libdir/netscape/plugins ]; then
    %_sbindir/update-alternatives --install \
        %_libdir/netscape/plugins/javaplugin.so javaplugin.so \
        %java_home/jre/plugin/%libarch/netscape4/javaplugin.so %priority
fi

%preun plugin-netscape4
if [ $1 = 0 ]; then
    %_sbindir/update-alternatives --remove javaplugin.so \
        %java_home/jre/plugin/%libarch/netscape4/javaplugin.so
fi
%endif

%files -f libs.list
%doc j2sdk%jdkver/jre/CHANGES
%doc j2sdk%jdkver/jre/COPYRIGHT
%doc j2sdk%jdkver/jre/LICENSE
%doc j2sdk%jdkver/jre/README
%doc j2sdk%jdkver/jre/Welcome.html
%doc j2sdk%jdkver/README.alt
%_sysconfdir/buildreqs/packages/substitute.d/%name
%dir %java_home
%dir %java_home/jre
%dir %java_home/jre/plugin
%dir %java_home/jre/plugin/%libarch
%dir %java_home/jre/lib
%dir %java_home/jre/lib/security
%dir %_datadir/%name
%java_home/jre/JavaPluginControlPanel.html
%java_home/jre/bin
%java_home/jre/lib/*.jar
%java_home/jre/lib/applet
%java_home/jre/lib/audio
%java_home/jre/lib/cmm
%java_home/jre/lib/ext
%java_home/jre/lib/fonts
%java_home/jre/lib/im
%java_home/jre/lib/images
%java_home/jre/lib/locale
%java_home/jre/lib/zi
%config(noreplace) %java_home/jre/lib/*.properties
%config(noreplace) %java_home/jre/lib/*.properties.??
%config(noreplace) %java_home/jre/lib/%libarch/jvm.cfg
%config(noreplace) %java_home/jre/lib/security/cacerts
%config(noreplace) %java_home/jre/lib/security/java.policy
%config(noreplace) %java_home/jre/lib/security/java.security
%doc %java_home/jre/lib/%libarch/*/Xusage.txt
%java_home/jre/lib/security/*.jar
%_man1dir/java%label.1*
%_man1dir/keytool%label.1*
%_man1dir/orbd%label.1*
%_man1dir/policytool%label.1*
%_man1dir/rmid%label.1*
%_man1dir/rmiregistry%label.1*
%_man1dir/servertool%label.1*
%_man1dir/tnameserv%label.1*

%files devel
%doc j2sdk%jdkver/README*
%doc j2sdk%jdkver/LICENSE
%doc j2sdk%jdkver/COPYRIGHT
%doc j2sdk%jdkver/jre/lib/*.txt
%_sysconfdir/buildreqs/packages/substitute.d/%name-devel
%config %java_home/j2se.*sh
%java_home/bin
%java_home/lib
%java_home/include
%_man1dir/appletviewer%label.1*
%_man1dir/extcheck%label.1*
%_man1dir/idlj%label.1*
%_man1dir/jar%label.1*
%_man1dir/jarsigner%label.1*
%_man1dir/javac%label.1*
%_man1dir/javadoc%label.1*
%_man1dir/javah%label.1*
%_man1dir/javap%label.1*
%_man1dir/jdb%label.1*
%_man1dir/native2ascii%label.1*
%_man1dir/rmic%label.1*
%_man1dir/serialver%label.1*

%files source
%_datadir/%name/src.zip

%files demo
%_datadir/%name/demo

%files plugin-mozilla
%java_home/jre/plugin/%libarch/mozilla

%if_enabled ns4_plugin
%files plugin-netscape4
%java_home/jre/plugin/%libarch/netscape4
%endif

%files jdbc
%java_home/jre/lib/%libarch/libJdbcOdbc.so

%changelog
* Wed Nov 12 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1_01-alt3
- Obsoletes j2se1.4-blackdown-fonts (bug #3243)
- Corrected build directory
- Relaxed textrel check on ELF files

* Mon Oct 20 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1_01-alt2
- Sync with the latest j2se1.4-sun
- Removed fonts package; j2se1.4-blackdown has got symlink
  to the fonts directory provided by j2se-sun-fonts
- Added locations of binary libraries to findprov lib path

* Tue Feb 18 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.4.1_01-alt1
- Ported from the j2se1.4-sun package
